/*
 *   'Reads in D:\PICK6 and prints D:\RECENT.PRN
 *   'RECENT.PRN contains each week's winners by how many weeks have
 *   '           elapsed since last occurrence.
 *   'W = game date  N= week number W%()= week's winning numbers
 *   'A%()= weeks elapsed since number came out
 *   'Y%()= weeks elapsed for this week's winning numbers
 */

#include <stdio.h>
#include <stdlib.h>
#define  NOS           47

static int    wel[7];        /* Y%()= weeks elapsed of winners            */

main()
{ static int  wen[NOS],      /* A%()= weeks elapsed since number came out */
              win[7],        /* W%()= week's winning numbers              */
            i,j,k,l,         /* i = current top number; jkl misc counters */
              hinum =0,      /* highest elapsed weeks                     */
              game=0;        /* game number = N in BAS                    */
  long        date;
  char        buf[81];
  void        quicksort(int, int);           /* function prototype */

  for(j=1; j<NOS; j++) wen[j] = 1;     /* all 1 to allow for prior weeks */

  for(j=43; j<NOS; j++) wen[j] = -213;         /* adj nums added Jan 89  */


  gets(buf);                                /* read in first week   */
  for( j=1, k=11; j<7; j++, k+=5)
              {  win[j] = atoi( &buf[k] );  /* get first week's winners */
                 wen[ win[j] ] = 0;         /* & zero elapsed weeks for it */
              }

  while( gets(buf) != NULL )                /* read & process the rest */
          { date = atol(buf);               /* read in date         */
            for( j=1, k=11; j<7; j++, k+=5)
              {  win[j] = atoi( &buf[k] );  /* read this week's winners */
                 wel[j] = wen[ win[j] ];    /* store weeks elapsed for the */
              }                             /* week's winners             */

            quicksort( 1,6 );               /* sort wel[] elapsed         */

            printf("%ld", date);            /* print line                 */
            for( j=1; j<7; j++)
                printf("%4d", wel[j]);
            putchar('\n');
                                                 /* bump all elapsed      */
            for(j=1; j<NOS;j++)
                { wen[j]++;if(hinum < wen[j]) hinum = wen[j];  }

            for(j=1; j<7;j++) wen[ win[j] ] = 0; /* reset winners to zero */
          }
  putchar('\n');

  for(j=0; j<9;j++)            /* print elapsed for all numbers  */
     { for(k=1; k + j < NOS;k+=9)
          printf("%6d%4d", j+k, wen[j+k]);
       putchar('\n');
     }
  putchar('\n');

  for(j=0; j <= hinum;j++)            /* print numbers by elapsed       */
    { i=0;
      for(k=1; k<NOS; k++)
        if( wen[k] == j )
          { if( i==0 ) { i=1; printf("\n%4d. ",j); }      /* prt age  */
            printf("%4d",k);
    }     }
  putchar('\n');

  putchar(7); printf("All Done.\n");

}                /*   end of main()      */

/*
    Quicksorts an array of integers, recursing to sort subsets
    of the array.  Called with the index to the left and right
    members of the array to be sorted.
*/

void quicksort(int left, int right)
{
    int i, j, t;                    /* some scratch variables */

    if(right > left)                /* skip unnecessary calls */
    {
        i = left-1; j = right;      /* initialize scan pointers */
                                    /* partition array on value */
                                    /* of the rightmost item */
        do {
                                    /* scan right for item >=  */
                                    /* than partitioning value */
            do i++;
                while(wel[i] < wel[right]);
                                    /* scan left for item <=   */
                                    /* than partitioning value */
            do j--;
                while(wel[j] > wel[right] && j > 0);
            t = wel[i];           /* interchange the items */
            wel[i] = wel[j];
            wel[j] = t;
        } while(j > i);             /* do until pointers cross */

        wel[j] = wel[i];        /* undo the last swap and */
        wel[i] = wel[right];    /* put the partitioning */
        wel[right] = t;           /* element into position */
        quicksort(left, i-1);       /* sort items to left of */
                                    /* partitioning element */
        quicksort(i+1, right);      /* sort items to right of */
    }                               /* partitioning element */
}         /* end of quicksort()  */
